
class pcy_sk
{
    // All tables are extracted from generated .c file.
    // They are positioned at place $T (in the beginning of 
	// Java parser skeleton file) is found by the
    // tool program. These tables are readonly. So it
    // is best to declare them as static constants.
    // In .c file, they are const int array.
	$T


	private static String pcyyerrsrc;

	// Constructor for yacc class 
	public pcy_sk(FileInputStream lex_fis, String input_file_name)
	{
		pcl_sk lexobject = new pcl_sk(lex_fis);
		set_input_file_name(input_file_name);
		yyparse(lexobject);
	}

    // These fields are declared in Skeleton for Java.
    private static imp_union yylval = new imp_union();
    private static imp_union yyval = new imp_union();
    private static int pcyyerrfl=0;
    private static int pcyyerrcnt=0;
    private static int pcyytoken=-1;
	
    private static int pcyylineno;

	private static void set_input_file_name(String fname)
	{
		pcyyerrsrc = fname;
	}
	
    int yyparse(pcl_sk lexobject)
    {
        int yyxi=0;
        int yyps=-1;    // index for accessing state stack.
        int yypv=-1;    // index for accessing value stack.
        int yypvt=0;
        int j;
        int m;
        int n;
        int tempstate=0;
        int statestack[]=new int[YYMAXDEPTH];
        imp_union[] yyv=new imp_union[YYMAXDEPTH];

    enstack:
        while (true)    // psudo loop for removing goto enstack.
        {
            if (++yyps>YYMAXDEPTH-1)
            {
                yyerror("pcyacc internal stack overflow", "", lexobject);
                return 1;
            }
            statestack[yyps]=tempstate;
            yypv++; 

			if (yyval==null)
				yyv[yypv] = yyval;
			else
				yyv[yypv] = (imp_union)yyval.clone();
            

    newstate:
            while (true)    // psudo loop for removing goto newestate
            {
                n=yypact[tempstate];
                if (n>PCYYFLAG)    // if statement changed to bypass goto
                {
                    if (pcyytoken<0)
                    {
                        if ((pcyytoken=lexobject.yylex())<0)
                        {
                            pcyytoken=0;
                        }
						System.out.println("tokenvalue=["+pcyytoken+"], actual token=["+yydisplay(pcyytoken)+"]");
                    }
                    if ((n+=pcyytoken)>=0&&n<YYLAST)
                    {
                        if (yychk[n=yyact[n]]==pcyytoken)
                        {
                            pcyytoken=-1;

							if (yylval==null)
								yyval = yylval;
							else
								yyval = (imp_union)yylval.clone();
                            
                            tempstate=n;
                            if (pcyyerrfl>0)
                            {
                                pcyyerrfl--;
                            }
                            continue enstack;
                        }
                    }
                }
    defaultact:
                if ((n=yydef[tempstate])==-2)
                {
                    if (pcyytoken<0)
                    {
                        if ((pcyytoken=lexobject.yylex())<0)
                        {
                            pcyytoken=0;
                        }
						System.out.println("tokenvalue=["+pcyytoken+"], actual token=["+yydisplay(pcyytoken)+"]");
                    }
                    for (yyxi=0;(yyexca[yyxi]!=-1)||(yyexca[yyxi+1]!=tempstate);yyxi+=2)
                    {
                        n=n;
                    }
                    while (yyexca[yyxi+=2]>=0)
                    {
                        if (yyexca[yyxi]==pcyytoken)
                        {
                            break;
                        }
                    }
                    if ((n=yyexca[yyxi+1])<0)
                    {
                        return 0;
                    }
                }
                if (n==0)
                {
                    switch (pcyyerrfl)
                    {
                        case WAS0ERR:
                            yyerror("syntax error", yydisplay(pcyytoken), lexobject);
							if ((n=yypact[tempstate])>PCYYFLAG && n<YYLAST)
							{
								int x;
								for (x=(n>0)?n:0; x<YYLAST; ++x)
								{
									if (yychk[yyact[x]]==x-n && x-n!=YYERRCODE)
										yyerror(null, yydisplay(x-n), lexobject);
								}
								yyerror(null, null, lexobject);
							}
							yyerror(null, null, lexobject);
                            pcyyerrcnt++;
                        case WAS1ERR:
                        case WAS2ERR:
                            pcyyerrfl=3;
                            while (yyps>=0)
                            {
                                n=yypact[statestack[yyps]]+YYERRCODE;
                                if (n>=0&&n<YYLAST&&yychk[yyact[n]]==YYERRCODE)
                                {
                                    tempstate=yyact[n];
                                    continue enstack;
                                }
                                n=yypact[statestack[yyps]];
                                --yyps;
                                --yypv;
                            }
    yyabort:
                            return 1;
                        case WAS3ERR:
                            if (pcyytoken==0)
                            {
                                return 1;
                            }
                            pcyytoken=-1;
                            continue newstate;
                        default:
                            break newstate;
                    }    // end of switch
                }
                else
                {
                    break newstate;    // avoid dead loop.
                }
            }    // end of while at newstate
            yyps-=yyr2[n];
            yypvt=yypv;
            yypv-=yyr2[n];

			if (yyv[yypv+1]==null)
				yyval = yyv[yypv+1];
			else
				yyval = (imp_union)yyv[yypv+1].clone();
           
            m=n;
            n=yyr1[n];
            j=yypgo[n]+statestack[yyps]+1;
            if ((j>=YYLAST)||(yychk[(tempstate=yyact[j])]!=-n))
            {
                tempstate=yyact[yypgo[n]];
            }
            switch (m)
            {
				$A
            }
        }    // end of while at enstack
    }

    // this one used to be a macro
    private static void yyerrok()
    {
        pcyyerrfl=0;
    }

	int get_yyerrcnt()
	{
		return pcyyerrcnt;
	}

	public static String yydisplay(int ch)
	{
		int i =0, tok_index = 0;

		/* utility program will create token number here */
		/*int tok_num;
		String[] tok = new String[tok_num];*/

		/* token list which is handled by pcytool */	
        $$ 
	
		switch (ch)
		{
			case 0:
				return ("[end of file]");
			case YYERRCODE:
				return ("[error]");
			case '\b':
				return ("'\\b'");
			case '\f':
				return ("'\\f'");
			case '\n':
				return ("'\\n'");
			case '\r':
				return ("'\r'");
			case '\t':
				return ("'\t'");
		}

		if (ch>YYERRCODE && ch<YYERRCODE+tok_num)
			return (tok[ch-(YYERRCODE+1)]);  /* is %token */
		return "char \""+(char)ch+"\""; 
	}

	void yyerrprefix(String msg, pcl_sk lexobject)
	{
		int punct = 0;
		
		pcyylineno = lexobject.get_yylineno();

		System.err.print("error [");
		System.err.print(pcyyerrcnt+1);
		System.err.print("] ");

		if (pcyyerrsrc.length()!=0)   /* any input file name? */
		{
			System.err.print("file ");
			System.err.print("'"+pcyyerrsrc+"'");
			punct = 1;
		}

		if (pcyylineno>=0)    /* valid line number? */
		{
			if (punct!=0)
				System.err.print(",");
			System.err.print("line "+pcyylineno);
			punct = 1;
		}

		if (String.valueOf(lexobject.get_yytext()).length()!=0)
		{
			if (punct!=0)
				System.err.print(" ");
			System.err.print("near \"");
			System.err.print(lexobject.get_yytext());
			System.err.print("\"");
			punct = 1;
		}

		if (punct!=0)
			System.err.print(": ");

		System.err.println(msg);
	}

	public void yyerror(String s, String t, 
								pcl_sk lexobject)
	{
		String expecting = "expecting: ";
		int column = 0;
		int WIDTH = 80;

		if (s!=null)
		{
			if (column!=0)
				System.err.println();
		
			yyerrprefix(s, lexobject);
			
			if (t.length()==0)
				column = 0;
			else
			{
				System.err.print("actual: "+t);
				column = 8 + t.length();
			}
			list = 0;
		}
		else if (t!=null)
		{
			if (list==0)
			{
				if (column+t.length()+expecting.length()+1<WIDTH-2)
				{
					System.err.print(" ");
					System.err.print(expecting+t);
					column += 1 + expecting.length()+t.length();
				}
				else
				{
					System.err.println();
					System.err.print(expecting+t);
					column = 1 + expecting.length()+t.length();
				}
			}
			else
			{
				if (column+t.length()<WIDTH-2)
				{
					System.err.print(", "+t);
					column = 2 + t.length();
				}
				else
				{
					System.err.print(",\n "+t);
					column = 3 + t.length();
				}
			}
			++list;
		}
		else
		{
			System.err.println();
			column = list = 0;
		}
	}

	int list = 0;
	// Declare lexer object as the member of yacc class
	pcl_sk lexobject;
}
